diff --git a/examples/qt3d/scene2d/LogoControls.qml b/examples/qt3d/scene2d/LogoControls.qml
index a71cd0e8d..116c71a3e 100644
--- a/examples/qt3d/scene2d/LogoControls.qml
+++ b/examples/qt3d/scene2d/LogoControls.qml
@@ -50,7 +50,7 @@
 
 import QtQuick 2.0
 import QtQuick.Scene2D 2.9
-import QtQuick.Controls 1.4
+// import QtQuick.Controls 1.4
 import QtQuick.Layouts 1.2
 
 Rectangle {
@@ -109,7 +109,7 @@ Rectangle {
         }
     }
 
-    ColumnLayout {
+    Column {
         id: tipLayout
         anchors.left: parent.left
         anchors.leftMargin: 15
@@ -121,7 +121,7 @@ Rectangle {
         Text { text: "Middle click to (de)activate"; font.bold: true }
     }
 
-    ColumnLayout {
+    Column {
         id: colorLayout
         anchors.left: parent.left
         anchors.leftMargin: 15
@@ -133,47 +133,55 @@ Rectangle {
 
         Text { text: "Appearance"; font.bold: true; color: d.textColor }
         Text { text: "Ambient color RGB"; color: d.textColor }
-        RowLayout {
+        Row {
             Text { text: "R"; color: d.textColor }
-            Slider {
+            Rectangle {
                 id: color_r
-                Layout.fillWidth: true
-                minimumValue: 0
-                maximumValue: 255
-                value: 128
+//                 Layout.fillWidth: true
+                width: 100; height: 20
+                color: "darkgreen"
+                property int minimumValue: 0
+                property int maximumValue: 255
+                property int value: 128
             }
         }
-        RowLayout {
+        Row {
             Text { text: "G"; color: d.textColor }
-            Slider {
+            Rectangle {
                 id: color_g
-                Layout.fillWidth: true
-                minimumValue: 0
-                maximumValue: 255
-                value: 195
+//                 Layout.fillWidth: true
+                width: 100; height: 20
+                color: "green"
+                property int minimumValue: 0
+                property int maximumValue: 255
+                property int value: 195
             }
         }
-        RowLayout {
+        Row {
             Text { text: "B"; color: d.textColor }
-            Slider {
+            Rectangle {
                 id: color_b
-                Layout.fillWidth: true
-                minimumValue: 0
-                maximumValue: 255
-                value: 66
+//                 Layout.fillWidth: true
+                width: 100; height: 20
+                color: "cyan"
+                property int minimumValue: 0
+                property int maximumValue: 255
+                property int value: 66
             }
         }
         Text { text: "Shininess"; color: d.textColor }
-        Slider {
+        Rectangle {
             id: shining
-            Layout.fillWidth: true
-            minimumValue: 30
-            maximumValue: 90
-            value: 50
+//             Layout.fillWidth: true
+                width: 100; height: 20
+                color: "lightblue"
+            property int minimumValue: 30
+            property int maximumValue: 90
+            property int value: 50
         }
     }
 
-    ColumnLayout {
+    Column {
         id: transformLayout
 
         anchors.left: colorLayout.left
@@ -184,43 +192,49 @@ Rectangle {
 
         Text { text: "Item transform"; font.bold: true; color: d.textColor }
         Text { text: "Rotation"; color: d.textColor }
-        RowLayout {
+        Row {
             Text { text: "X"; color: d.textColor }
-            Slider {
+            Rectangle {
                 id: rotation_x
-                Layout.fillWidth: true
-                minimumValue: -45
-                maximumValue: 45
-                value: d.rotationValue
+//                 Layout.fillWidth: true
+                width: 100; height: 20
+                color: "yellow"
+                property int minimumValue: -45
+                property int maximumValue: 45
+                property int value: d.rotationValue
             }
         }
-        RowLayout {
+        Row {
             Text { text: "Y"; color: d.textColor }
-            Slider {
+            Rectangle {
                 id: rotation_y
-                Layout.fillWidth: true
-                minimumValue: -45
-                maximumValue: 45
-                value: d.rotationValue
+//                 Layout.fillWidth: true
+                width: 100; height: 20
+                color: "orange"
+                property int minimumValue: -45
+                property int maximumValue: 45
+                property int value: d.rotationValue
             }
         }
-        RowLayout {
+        Row {
             Text { text: "Z"; color: d.textColor }
-            Slider {
+            Rectangle {
                 id: rotation_z
-                Layout.fillWidth: true
-                minimumValue: -45
-                maximumValue: 45
-                value: d.rotationValue
+//                 Layout.fillWidth: true
+                width: 100; height: 20
+                color: "red"
+                property int minimumValue: -45
+                property int maximumValue: 45
+                property int value: d.rotationValue
             }
         }
 
-        RowLayout {
-            CheckBox { id: animation; text: "Animation"; checked: false }
+        Row {
+            Text { id: animation; text: "Animation"; width: 20; height: 20 }
         }
     }
 
-    ColumnLayout {
+    Column {
         id: cameraLayout
 
         anchors.left: colorLayout.left
@@ -231,12 +245,14 @@ Rectangle {
 
         Text { text: "Object"; font.bold: true; color: d.textColor }
         Text { text: "Logo Center Z"; color: d.textColor }
-        Slider {
+        Rectangle {
             id: logoCenter_z
-            Layout.fillWidth: true
-            minimumValue: -10
-            maximumValue: 8
-            value: 0
+//             Layout.fillWidth: true
+            width: 20; height: 20
+            color: "lightsteelblue"
+            property int minimumValue: -10
+            property int maximumValue: 8
+            property int value: 0
         }
     }
 }
diff --git a/examples/qt3d/scene2d/main.qml b/examples/qt3d/scene2d/main.qml
index ceaac3b34..8b6d64d9e 100644
--- a/examples/qt3d/scene2d/main.qml
+++ b/examples/qt3d/scene2d/main.qml
@@ -55,7 +55,6 @@ import Qt3D.Input 2.0
 
 import QtQuick 2.0
 import QtQuick.Scene2D 2.9
-import QtQuick.Controls 1.4
 import QtQuick.Layouts 1.2
 
 Entity {